﻿Imports System.Runtime.InteropServices
Imports System

Imports System.IO


Public Class Form1

    Dim hbitmap As IntPtr

    Private WSQ_library_native_methods As WSQImageLibraryNativeMethods32

    Private bp As IntPtr
    Private b As System.Drawing.Bitmap

    Private type8_image_compression_type As Int32
    Private result_string As String
    Private save_type8_binary_field_filename As String
    Private image_size_txt_file As String

    Private type8_binary_field_ptr As IntPtr
    Private type8_binary_field As Byte()
    Private type8_binary_field_length As Int32

    Private type8_image_width As Int32
    Private type8_image_height As Int32

    Private input_data_stream As Byte()
    Private input_data_stream2 As Byte()
    Private output_data_stream As Byte()
    Private output_data_stream2 As Byte()
    Private pwidth As Int32
    Private pheight As Int32
    Private ppi As Int32
    Private comment_text As String
    Private bitrate As Double

    Private h, w As Int32

    Dim lpszDialogFileName As String


    'To call functions from WSQ_library.dll
    'you can use the methods from wrapper class WSQImageLibraryNativeMethods
    'or you can use function prototypes provided below 

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _CreateNISTType8BinaryFieldfromHBITMAP(ByVal input_HBITMAP As IntPtr, ByVal type8_binary_field_compression_type As Int32) As IntPtr
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _CreateHBITMAPfromNISTType8BinaryField(ByVal type8_image_width As Int32, ByVal type8_image_height As Int32, ByVal type8_compression_type As Int32, <[In]()> ByVal type8_input_byte_array As Byte(), ByVal type8_input_byte_array_size As Int32) As IntPtr
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _ReadSizeOfNISTType8BinaryField() As Int32
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _ReadType8DataCompressionType() As Int32
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _ReadType8DataWidth() As Int32
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _ReadType8DataHeight() As Int32
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _SetNISTType8ImageColorInversion(ByVal in_uncompressed_type8_image_inverted As Int32, ByVal out_uncompressed_type8_image_inverted As Int32, ByVal in_compressed_type8_image_inverted As Int32, ByVal out_compressed_type8_image_inverted As Int32) As Int32
    End Function



    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _CreateBMPFromFile(ByVal lpszFileName As String) As IntPtr
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _SaveBMPToFile(ByVal hBitmap As IntPtr, ByVal lpszFileName As String, ByVal ifiletype As Short) As Short
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Sub _SetShowFilePropertiesDialog(ByVal file_properties_dialog As Integer)
    End Sub

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Sub _ShowFileConverter()
    End Sub

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, ByVal lpszFileName As String) As Short
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _GenerateSerialNumber() As IntPtr
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Ansi)> _
    Shared Function _UnlockWSQLibrary(ByVal lpszAuthorizationCode As String) As Short
    End Function



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        WSQ_library_native_methods = New WSQImageLibraryNativeMethods32

        type8_binary_field_ptr = IntPtr.Zero

        comboBoxCompression.Items.Add("Uncompressed")
        comboBoxCompression.Items.Add("ANSI/EIA-538-1988 facsimile compression")
        comboBoxCompression.SelectedIndex = 0

        textBoxWidth.Text = "0"
        textBoxHeight.Text = "0"


    End Sub


    Private Sub buttonOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonOpen.Click

        OpenFileDialog1.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp;|FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|Windows bitmaps (*.bmp)|*.bmp|Macintosh TIFF images (*.tiff)|*.tiff|PC TIFF images (*.tif)|*.tif|JPG images (*.jpg)|*.jpg|" & _
        "JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|JPE images (*.jpe)|*.jpe|JPEG images (*.jpeg)|*.jpeg|Portable network graphic images (*.png)|*.png|Compuserve Graphic Interchange Format(*.gif)|*gif|Paintshop Pro images (*.psp)|*.psp|JFIF images (*.jfif)|*.jfif|Run length encoded Windows bitmaps (*.rle)|*.rle|Device independant Windows bitmaps (*.dib)|*.dib|Truevision images (*.win)|*.win|Truevision images (*.vst)|*.vst|Truevision images (*.vda)|*.vda|" & _
        "Truevision images (*.tga)|*.tga|Truevision images (*.icb)|*.icb|GFI fax images (*.fax)|*.fax|Encapsulated Postscript images (*.eps)|*.eps|ZSoft Paintbrush images (*.pcx)|*.pcx|ZSoft Paintbrush images (*.pcc)|*.pcc|Word 5.x screen capture images (*.scr)|*.scr|Alias/Wavefront images (*.rpf)|*.rpf|Alias/Wavefront images (*.rla)|*.rla|SGI true color images (*.sgi)|*.sgi|SGI true color images with alpha (*.rgba)|*.rgba|SGI true color images (*.rgb)|*.rgb|SGI black/white images (*.bw)|*.bw|" & _
        "Photoshop images (*.psd)|*.psd|Photoshop images (*.pdd)|*.pdd|Portable pixel map images (*.ppm)|*.ppm|Portable gray map images (*.pgm)|*.pgm|Portable bitmap images (*.pbm)|*.pbm|Autodesk images (*.cel)|*.cel|Autodesk images (*.pic)|*.pic|Kodak Photo-CD images (*.pcd)|*.pcd|Dr. Halo images (*.cut)|*.cut|Amiga Bitmap Graphic (8 bits)|*.iff|Windows icons (*.ico)|*.ico|Windows metafiles (*.wmf)|*.wmf|Windows enhanced meta files (*.emf)|*.emf"

        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'hbitmap = _CreateBMPFromFile(OpenFileDialog1.FileName)
        hbitmap = WSQ_library_native_methods.pCreateBMPFromFile(OpenFileDialog1.FileName)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        h = OutputPicture.Image.Height
        w = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, w, h)

        textBoxWidth.Text = Convert.ToString(w)
        textBoxHeight.Text = Convert.ToString(h)

        buttonSave.Enabled = True
        ConvertToType8Button.Enabled = True

    End Sub





    Private Sub buttonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSave.Click

        Dim iResult As Short

        ' Set filters.
        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq|Windows BMP (*.bmp)|*.bmp|TIFF Files (*.tif)|*.tif|PNG Files (*.png)|*.png|" & _
        "JPEG Files (*.jpg)|*.jpg|Targa Files (*.tga)|*.tga|SGI Files (*.rgb)|*.rgb|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc"

        ' Specify default filter.
        SaveFileDialog1.FilterIndex = 1

        SaveFileDialog1.FileName = ""


        If (SaveFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        '_SetShowFilePropertiesDialog(1)
        WSQ_library_native_methods.pSetShowFilePropertiesDialog(1)

        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'iResult = _SaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)
        iResult = WSQ_library_native_methods.pSaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

        'Dim objBitmap As Bitmap
        'objBitmap = OutputPicture.Image
        'iResult = _SaveBMPToFile(objBitmap.GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)


    End Sub

    Private Sub ConvertFromType8Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConvertFromType8Button.Click


        ConvertToType8Button.Enabled = False
        ConvertFromType8Button.Enabled = False
        buttonOpen.Enabled = False
        buttonSave.Enabled = False


        OpenFileDialog1.Filter = "Type8 binary images|*.bin"

        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog() <> DialogResult.OK) Then
            ConvertFromType8Button.Enabled = True
            buttonOpen.Enabled = True
            Exit Sub
        End If


        image_size_txt_file = Path.ChangeExtension(OpenFileDialog1.FileName, ".txt")

        If (File.Exists(image_size_txt_file)) Then

            ' Create an instance of StreamReader to read from a file.
            ' The using statement also closes the StreamReader.
            Dim sr As System.IO.StreamReader
            sr = My.Computer.FileSystem.OpenTextFileReader(image_size_txt_file)

            type8_image_compression_type = Convert.ToInt32(sr.ReadLine())  ' type8_image_compression_type = int.Parse(sr.ReadLine())
            type8_image_width = Convert.ToInt32(sr.ReadLine())
            type8_image_height = Convert.ToInt32(sr.ReadLine())
            sr.Close()

            textBoxWidth.Text = Convert.ToString(type8_image_width)
            textBoxHeight.Text = Convert.ToString(type8_image_height)

            'if (File.Exists(image_size_txt_file)) 
        Else
            type8_image_width = Convert.ToInt32(textBoxWidth.Text)
            type8_image_height = Convert.ToInt32(textBoxHeight.Text)
        End If


        If ((type8_image_width = 0) Or (type8_image_height = 0)) Then
            MessageBox.Show("You must manually set the type8_image_width and type8_image_height and compression type of the image.")
            ConvertFromType8Button.Enabled = True
            buttonOpen.Enabled = True
            Return
        End If


        comboBoxCompression.SelectedIndex = type8_image_compression_type


        Dim fInfo As IO.FileInfo = New IO.FileInfo(OpenFileDialog1.FileName)
        Dim input_stream_length As Long = fInfo.Length
        Dim fStream As IO.FileStream = New IO.FileStream(OpenFileDialog1.FileName, IO.FileMode.Open, IO.FileAccess.Read)
        Dim br As IO.BinaryReader = New IO.BinaryReader(fStream)

        input_data_stream = br.ReadBytes(input_stream_length)


        bp = _CreateHBITMAPfromNISTType8BinaryField(type8_image_width, type8_image_height, type8_image_compression_type, input_data_stream, input_stream_length)

        b = Image.FromHbitmap(bp)
        OutputPicture.Image = b

        h = OutputPicture.Image.Height
        w = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, w, h)


        ConvertToType8Button.Enabled = True
        ConvertFromType8Button.Enabled = True
        buttonOpen.Enabled = True
        buttonSave.Enabled = True



    End Sub


    Private Sub ConvertToType8Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConvertToType8Button.Click


        ConvertToType8Button.Enabled = False
        ConvertFromType8Button.Enabled = False


        ' Set filters.
        SaveFileDialog1.Filter = "BIN Files (*.bin)|*.bin"

        ' Specify default filter.
        SaveFileDialog1.FilterIndex = 1

        SaveFileDialog1.FileName = ""


        If (SaveFileDialog1.ShowDialog() <> DialogResult.OK) Then
            ConvertToType8Button.Enabled = True
            ConvertFromType8Button.Enabled = True
            Exit Sub
        End If


        type8_image_width = Convert.ToInt32(textBoxWidth.Text)
        type8_image_height = Convert.ToInt32(textBoxHeight.Text)
        type8_image_compression_type = comboBoxCompression.SelectedIndex

        image_size_txt_file = Path.ChangeExtension(SaveFileDialog1.FileName, ".txt")



        Dim sw As System.IO.StreamWriter
        sw = My.Computer.FileSystem.OpenTextFileWriter(image_size_txt_file, True)
        sw.WriteLine(type8_image_compression_type.ToString())
        sw.WriteLine(type8_image_width.ToString())
        sw.WriteLine(type8_image_height.ToString())
        sw.Close()


        b = New Bitmap(OutputPicture.Image)
        bp = b.GetHbitmap()

        save_type8_binary_field_filename = Path.ChangeExtension(SaveFileDialog1.FileName, ".bin")

        type8_binary_field_ptr = _CreateNISTType8BinaryFieldfromHBITMAP(bp, type8_image_compression_type)
        type8_binary_field_length = _ReadSizeOfNISTType8BinaryField()

        'MessageBox.Show(type8_binary_field_length.ToString())

        Dim type8_binary_field(type8_binary_field_length) As Byte

        Marshal.Copy(type8_binary_field_ptr, type8_binary_field, 0, type8_binary_field_length)


        'Dim fStream As IO.FileStream = New IO.FileStream(save_type8_binary_field_filename, IO.FileMode.CreateNew)
        Dim fStream As IO.FileStream = New IO.FileStream(save_type8_binary_field_filename, IO.FileMode.Create)
        Dim bw As IO.BinaryWriter = New IO.BinaryWriter(fStream)

        bw.Write(type8_binary_field)
        bw.Close()
        fStream.Close()

        result_string = "The converted file was saved as:" & vbCrLf & save_type8_binary_field_filename
        MessageBox.Show(result_string)

        ConvertToType8Button.Enabled = True
        ConvertFromType8Button.Enabled = True

    End Sub
End Class
